/*
 * Author: Stefan Andritoiu <stefan.andritoiu@intel.com>
 * Copyright (c) 2015 Intel Corporation.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

public class PPD42NSSample {

	public static void main(String[] args) throws InterruptedException {
		// ! [Interesting]
		// Instantiate a dust sensor on GPIO pin D8
		upm_ppd42ns.PPD42NS dust = new upm_ppd42ns.PPD42NS(8);
		upm_ppd42ns.dustData data;

		System.out.println("This program will give readings every 30 seconds until you stop it");

		while (true) {
			data = dust.getData();

			System.out.println("Low pulse occupancy: " + data.getLowPulseOccupancy());
			System.out.println("Ratio:  " + data.getRatio());
			System.out.println("Concentration: " + data.getConcentration());
		}
		// ! [Interesting]
	}

}